Holger's Java API

## com.antelmann.calendar
Class JDayGrid

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  com.antelmann.calendar.JDayGrid

All Implemented Interfaces:
  ImageObserver, MenuContainer, Serializable

    public class JDayGrid

extends JComponent

Author:
  Holger Antelmann
See Also:
  Serialized Form

Nested Class Summary
`static class` `JDayGrid.Orientation`

Nested classes/interfaces inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Nested classes/interfaces inherited from class java.awt.Container
`Container.AccessibleAWTContainer`

Nested classes/interfaces inherited from class java.awt.Component
`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

Field Summary
`protected int` `beginTime` time in millis from day start
`static CalendarEntryComponentFactory` `defaultFactory` uses JCalendarEntry objects
`protected int` `endTime` time in millis from day start
`protected Color` `gridColor` used to draw time interval lines
`protected int` `gridPixel` other size of the grid in pixels
`protected int` `intervalPixel` size of one time interval in pixels
`protected Color` `textColor` used to draw time interval text
`protected int` `timeInterval` time in millis, used for displaying an interval w/ a line
`protected int` `timeSnapInterval` time in millis, used for snapping

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`JDayGrid()`
`JDayGrid(Date date)`
`JDayGrid(Date date, JDayGrid.Orientation orientation)`
`JDayGrid(Date date, JDayGrid.Orientation orientation, boolean printText)`
`JDayGrid(Date date, JDayGrid.Orientation orientation, boolean printText, CalendarEntryComponentFactory factory)`
`JDayGrid(JDayGrid.Orientation orientation)`

Method Summary
`int` `getBeginTime()` time in millisec from the begin of the day
`CalendarEntryComponentFactory` `getComponentFactory()`
`Component` `getComponentFor(CalendarEntry entry)`
`Date` `getDate()`
`int` `getEndTime()` time in millisec from the begin of the day
`int` `getGridPixel()`
`int` `getIntervalPixel()` the number of pixels representing a time interval
`boolean` `getPrintText()`
`Date` `getTimeFor(Point p)` returns the time that corresponds to the given point
`int` `getTimeInterval()` the time interval used for dwawing (in milliseconds)
`int` `getTimeSnapInterval()`
`protected void` `paintComponent(Graphics g)`
`Component` `placeEntry(CalendarEntry entry)` uses the configured CalendarEntryComponentFactory
`void` `removeAll()` does not only remove all components, but also the associations from a CalendarEntry to a component
`void` `setBeginTime(int beginTime)` time in millisec from the begin of the day
`void` `setComponentFactory(CalendarEntryComponentFactory factory)` used to create the component when calling `placeEntry(CalendarEntry)`
`void` `setDate(Date date)` also performs a call to `removeAll`
`void` `setEndTime(int endTime)` time in millisec from the begin of the day
`void` `setGridPixel(int pixel)`
`void` `setIntervalPixel(int pixels)`
`void` `setPrintText(boolean flag)`
`void` `setTimeInterval(int millis)`
`void` `setTimeSnapInterval(int snapInterval)`

Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getAccessibleContext, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update, updateUI`

Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### defaultFactory

    public static final CalendarEntryComponentFactory defaultFactory

  uses JCalendarEntry objects

  See Also:
    `JCalendarEntry`

### gridColor

    protected Color gridColor

  used to draw time interval lines

### textColor

    protected Color textColor

  used to draw time interval text

### beginTime

    protected int beginTime

  time in millis from day start

### endTime

    protected int endTime

  time in millis from day start

### timeInterval

    protected int timeInterval

  time in millis, used for displaying an interval w/ a line

### timeSnapInterval

    protected int timeSnapInterval

  time in millis, used for snapping

### intervalPixel

    protected int intervalPixel

  size of one time interval in pixels

### gridPixel

    protected int gridPixel

  other size of the grid in pixels

Constructor Detail

### JDayGrid

    public JDayGrid()

### JDayGrid

    public JDayGrid(Date date)

### JDayGrid

    public JDayGrid(JDayGrid.Orientation orientation)

### JDayGrid

    public JDayGrid(Date date,
                    JDayGrid.Orientation orientation)

### JDayGrid

    public JDayGrid(Date date,
                    JDayGrid.Orientation orientation,
                    boolean printText)

### JDayGrid

    public JDayGrid(Date date,
                    JDayGrid.Orientation orientation,
                    boolean printText,
                    CalendarEntryComponentFactory factory)

Method Detail

### setComponentFactory

    public void setComponentFactory(CalendarEntryComponentFactory factory)

  used to create the component when calling `placeEntry(CalendarEntry)`

### getComponentFactory

    public CalendarEntryComponentFactory getComponentFactory()

### placeEntry

    public Component placeEntry(CalendarEntry entry)

  uses the configured CalendarEntryComponentFactory

  Returns:
    null doesn't belong on this day grid (because it has the wrong beginTime) or the new component representing the entry. (or if the entry already exists?)
  See Also:
    `setComponentFactory(CalendarEntryComponentFactory)`

### removeAll

    public void removeAll()

  does not only remove all components, but also the associations from a CalendarEntry to a component

  Overrides:
    `removeAll` in class `Container`

### getComponentFor

    public Component getComponentFor(CalendarEntry entry)

### setDate

    public void setDate(Date date)

  also performs a call to `removeAll`

### getDate

    public Date getDate()

### getEndTime

    public int getEndTime()

  time in millisec from the begin of the day

### setEndTime

    public void setEndTime(int endTime)

  time in millisec from the begin of the day

### getBeginTime

    public int getBeginTime()

  time in millisec from the begin of the day

### setBeginTime

    public void setBeginTime(int beginTime)

  time in millisec from the begin of the day

### getPrintText

    public boolean getPrintText()

### setPrintText

    public void setPrintText(boolean flag)

### setTimeSnapInterval

    public void setTimeSnapInterval(int snapInterval)

### getTimeSnapInterval

    public int getTimeSnapInterval()

### getGridPixel

    public int getGridPixel()

### getTimeInterval

    public int getTimeInterval()

  the time interval used for dwawing (in milliseconds)

### setTimeInterval

    public void setTimeInterval(int millis)

### getIntervalPixel

    public int getIntervalPixel()

  the number of pixels representing a time interval

### setIntervalPixel

    public void setIntervalPixel(int pixels)

### setGridPixel

    public void setGridPixel(int pixel)

### getTimeFor

    public Date getTimeFor(Point p)

  returns the time that corresponds to the given point

### paintComponent

    protected void paintComponent(Graphics g)

  Overrides:
    `paintComponent` in class `JComponent`

(c) Holger Antelmann since 2001- all rights reserved (contact: info@antelmann.com)
see www.antelmann.com/developer for further details and available downloads